config/routes.rb
Rails.application.routes.draw do
  resources :departamentos
  resources :produtos, only: [:new, :create, :destroy, :edit, :update]
  get "/produtos/busca" => "produtos/busca", as: :busca_produto
  root "produtos#index"


  # post "/produtos" => "produtos#create"
  # get "/produtos/new" => "produtos#new"  
  # delete "/produtos/:id" => "produtos#destroy", as: :produto
  # get "produtos" => "produtos#index"
  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html
  # get "[o nome que queremos para a URL]" => "[nome do Controller]#[nome da página]"
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/departamento.rb
class Departamento < ApplicationRecord
end

app/models/produto.rb
class Produto < ApplicationRecord

    belongs_to :departamento

    validates :quantidade, :preco, :descricao, :nome, presence: true
    validates :nome, length: {minimum:5}
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/departamentos_controller.rb
class DepartamentosController < ApplicationController
  before_action :set_departamento, only: %i[ show edit update destroy ]

  # GET /departamentos or /departamentos.json
  def index
    @departamentos = Departamento.all
  end

  # GET /departamentos/1 or /departamentos/1.json
  def show
  end

  # GET /departamentos/new
  def new
    @departamento = Departamento.new
  end

  # GET /departamentos/1/edit
  def edit
  end

  # POST /departamentos or /departamentos.json
  def create
    @departamento = Departamento.new(departamento_params)

    respond_to do |format|
      if @departamento.save
        format.html { redirect_to @departamento, notice: "Departamento was successfully created." }
        format.json { render :show, status: :created, location: @departamento }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @departamento.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /departamentos/1 or /departamentos/1.json
  def update
    respond_to do |format|
      if @departamento.update(departamento_params)
        format.html { redirect_to @departamento, notice: "Departamento was successfully updated." }
        format.json { render :show, status: :ok, location: @departamento }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @departamento.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /departamentos/1 or /departamentos/1.json
  def destroy
    @departamento.destroy
    respond_to do |format|
      format.html { redirect_to departamentos_url, notice: "Departamento was successfully destroyed." }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_departamento
      @departamento = Departamento.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def departamento_params
      params.require(:departamento).permit(:nome)
    end
end

app/controllers/produtos_controller.rb
class ProdutosController < ApplicationController

    before_action :set_produto, only: [:edit, :update, :destroy]

    def index
        @produtos_por_nome = Produto.all           
        @produtos_por_preco = Produto.order(:preco).limit(3)
    end
   
    def new
        @produto = Produto.new
        renderiza :new
    end
    def edit       
        renderiza :edit
    end

    def busca
        @nome_a_buscar = params[:nome]
        @produtos = Produto.where "nome like ?", "%#{@nome_a_buscar}%"
    end
    def update          
        @produto.update produto_params
        if @produto.save
            flash[:notice] = "Produto atualizado com sucesso!"
            redirect_to root_url           
        else
            renderiza :edit
        end
    end
   

    def create        
        @produto = Produto.new produto_params
        if @produto.save
            flash[:notice] = "Produto salvo com sucesso!"
            redirect_to root_url           
        else
            renderiza :new
        end
    end

    def destroy             
        @produto.destroy 
        redirect_to root_url
    end

    private

    def set_produto 
        id = params[:id]
        @produto = Produto.find(id)
    
    end

    
    def renderiza (view)
    @departamentos = Departamento.all
    render view
    end

    def produto_params
        params.require(:produto).permit :nome, :descricao, :quantidade, :preco, :departamento_id
    end
    
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/departamentos_helper.rb
module DepartamentosHelper
end

app/helpers/produtos_helper.rb
module ProdutosHelper
end

app/views/departamentos/_form.html.erb
<%= form_with(model: departamento) do |form| %>
  <% if departamento.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(departamento.errors.count, "error") %> prohibited this departamento from being saved:</h2>

      <ul>
        <% departamento.errors.each do |error| %>
          <li><%= error.full_message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= form.label :nome %>
    <%= form.text_field :nome %>
  </div>

  <div class="actions">
    <%= form.submit %>
  </div>
<% end %>

app/views/departamentos/edit.html.erb
<h1>Editing Departamento</h1>

<%= render 'form', departamento: @departamento %>

<%= link_to 'Show', @departamento %> |
<%= link_to 'Back', departamentos_path %>

app/views/departamentos/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Departamentos</h1>

<table>
  <thead>
    <tr>
      <th>Nome</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @departamentos.each do |departamento| %>
      <tr>
        <td><%= departamento.nome %></td>
        <td><%= link_to 'Show', departamento %></td>
        <td><%= link_to 'Edit', edit_departamento_path(departamento) %></td>
        <td><%= link_to 'Destroy', departamento, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Departamento', new_departamento_path %>

app/views/departamentos/new.html.erb
<h1>New Departamento</h1>

<%= render 'form', departamento: @departamento %>

<%= link_to 'Back', departamentos_path %>

app/views/departamentos/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Nome:</strong>
  <%= @departamento.nome %>
</p>

<%= link_to 'Edit', edit_departamento_path(@departamento) %> |
<%= link_to 'Back', departamentos_path %>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Loja de Camisetas</title>
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_pack_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>

  <%= nav_bar brand: "Felstee", brand_link: root_url do %>  
      <%= form_tag busca_produto_path, method: :get, class: "navbar-form navbar-right" do %>
        <div class="form-group">
          <%= text_field_tag :nome, @nome_a_buscar, class: "form-control" %>
          <%= button_to "Buscar" , nil, class: "btn btn-default" %>
       </div>
      <% end %>
  <% end %>

  <div class="container">
  <%= yield %>
    </div>
  </body>
</html>

app/views/produtos/_form.html.erb
<% @produto.errors.full_messages.each do |message| %>
<div class="alert alert-danger" role="alert"><%=message%></div>
<% end %>


<%= form_for @produto do |f| %>

<div class="form-group">
    <%# <form action="/produto" method="post"> %>
    <%= f.label :nome %>
    <%= f.text_field :nome, class: "form-control" %>    
    <%# Nome <input type="text" name="produto[nome]"/><br/> %>
</div>
<div class="form-group">
    <%= f.label :descricao %>
    <%= f.text_area :descricao, class:"form-control" ,rows: 4 %>
    <%# Descrição <textarea name="produto[descricao]"></textarea><br/> %>
</div>
<div class="form-group">
<%= f.label :departamento %>
<%= f.collection_select :departamento_id, @departamentos, :id, :nome,{}, class: "form-control" %>
</div>

<div class="form-inline">
<div class="form-group">
    <%= f.label :quantidade %>
    <%= f.number_field :quantidade, step: 1, class: "form-control" %>
    <%# Quantidade <input type="number" name="produto[quantidade]"/><br/> %>
    </div>
    
    <div class="form-group">
    <%= f.label :preco %> 
    <%= f.number_field :preco, class: "form-control"%>
    <%# Preço <input type="number" name="produto[preco]" step="0.01"/><br/> %>

    <%= f.submit texto_da_acao, class: "btn btn-primary" %>
    <%# <button type="submit">Criar</button> %>
</div>

</form>
<% end %>

app/views/produtos/_produto.html.erb
    <tr>
        <td><%= produto.nome %></td>
        <td><%= produto.descricao %></td>
        <td><%= produto.preco %></td>
        <%# <td><%= produto.quantidade %></td>  
        <td>
             <%= button_to "Remover", produto, method: :delete , class: "btn btn-danger", 
             data: { confirm:"Realmente deseja remover #{produto.nome}?"} %>

        </td>    
        <td>
        <%= link_to "Alterar", edit_produto_path(produto), class:"btn btn-default" %>
        </td>

    </tr>

app/views/produtos/busca.html.erb
<table class = "table table-bordered">
    <thead>
        <tr>
            <th>Nome</th>
            <th>Descrição</th>
            <th>Preço</th>
            <%# <th>Quantidade</th> %>
        </tr>
    </thead>
    <tbody>
        <%# <% todos = Produto.all %> 
         <%# <% todos = Produto.order :nome %> 
        <%= render @produtos %>
    </tbody>
</table>

app/views/produtos/edit.html.erb
<%= render partial: 'form', locals: { texto_da_acao: 'Atualizar o produto' } %>

app/views/produtos/index.html.erb
<%if flash[:notice] %>
    <div class="alert alert-success" role="alert"><%= flash[:notice] %></div>
<%end%>


<table class = "table table-bordered">
    <thead>
        <tr>
            <th>Nome</th>
            <th>Descrição</th>
            <th>Preço</th>
            <%# <th>Quantidade</th>%>             
        </tr>
    </thead>
    <tbody>
       <%# <% todos = Produto.all %> 
         <%# <% todos = Produto.order :nome %> 
       <!--  <% @produtos_por_nome.each do |produto| %>
        <tr>
            <td><%= produto.nome %></td>
            <td><%= produto.descricao %></td>
            <td><%= produto.preco %></td>
            <td><%= produto.quantidade %></td>   
           <td>
            <%= button_to "Remover", produto, method: :delete , class: "btn btn-danger", 
            data: { confirm:"Realmente deseja remover #{produto.nome}?"} %>
            </td>         
        </tr>
        <% end %> -->
        <%= render @produtos_por_nome %>
    </tbody>
</table>

<table class ="table table-bordered">
     <thead>
        <tr>
            <th>Nome</th>
            <th>Descrição</th>
            <th>Preço</th>
            <%# <th>Quantidade</th> %>
        </tr>
    </thead>
    <tbody>
        <!--<%# <% todos = Produto.order :preco %>
        <% @produtos_por_preco.each do |produto| %>
        <tr>
            <td><%= produto.nome %></%></td>
            <td><%= produto.descricao %></%></td>
            <td><%= produto.preco %></%></td>
            <td><%= produto.quantidade %></%></td>
        </tr>
        <% end %> -->
        <%= render @produtos_por_preco %>
    </tbody>
</table>
<%= link_to "Criar novo produto", new_produto_path, class: "btn btn-primary" %>
<%= link_to "Criar novo Departamento", new_departamento_path, class: "btn btn-primary" %>
<%= link_to "Departamentos", departamentos_path, class: "btn btn-primary" %>
<%# <%= link_to "Criar novo produto", produtos_new_url %> 

app/views/produtos/new.html.erb
<%= render partial: 'form', locals: {texto_da_acao: 'Criar o produto' } %>